import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);
		
		// Read the number of cases and loop over the cases
		int case_no, cases = scanner.nextInt();
		for (case_no = 0; case_no < cases; case_no++) {
			
			// Read the matrix size
			int n = scanner.nextInt();
			
			// Create a new 2D array
			int[][] A = new int[n][n]; 
			int[][] sums = new int[n+1][n+1];
			int i, j;
			
			for (i = 0; i <= n; i++) {
				sums[0][i] = 0;
				sums[i][0] = 0;
			}
				
			
			// Read the matrix
			for (i = 0; i < n; i++) {
				for (j = 0; j < n; j++) {
					A[i][j] = scanner.nextInt();
					sums[i + 1][j + 1] = A[i][j] - sums[i][j] + sums[i + 1][j] + sums[i][j + 1];
				}
			}
			
			// Globally best sum we have seen
			// Note that we do not need to look at 0x0 matrices below
			int maxsum = 0;
			
			int top, bottom, left, right;
			
			// Try all rows as the first row of the submatrix
			for (top = 0; top < n; top++) {
				for (bottom = top; bottom < n; bottom++) {
					for (left = 0; left < n; left++) {
						for (right = left; right < n; right++) {
							int cursum = sums[top][left] + sums[bottom + 1][right + 1] - sums[bottom + 1][left] - sums[top][right + 1];
							if (cursum > maxsum)
								maxsum = cursum;
						}
					}
				}
			}
			
			System.out.println(maxsum);
		}
		scanner.close();
	}
}
